package org.objectweb.jinha.editor;
 
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.objectweb.jinha.editparts.AttributeEditPart;
import org.objectweb.jinha.editparts.AttributeListEditPart;
import org.objectweb.jinha.editparts.BusinessMethodEditPart;
import org.objectweb.jinha.editparts.BusinessMethodListEditPart;
import org.objectweb.jinha.editparts.CMPEditPart;
import org.objectweb.jinha.editparts.CMPListEditPart;
import org.objectweb.jinha.editparts.CMREditPart;
import org.objectweb.jinha.editparts.CMRListEditPart;
import org.objectweb.jinha.editparts.DiagramEditPart;
import org.objectweb.jinha.editparts.EntityEditPart;
import org.objectweb.jinha.editparts.FinderEditPart;
import org.objectweb.jinha.editparts.FinderListEditPart;
import org.objectweb.jinha.editparts.HomeMethodEditPart;
import org.objectweb.jinha.editparts.HomeMethodListEditPart;
import org.objectweb.jinha.editparts.MessageDrivenEditPart;
import org.objectweb.jinha.editparts.RelationEditPart;
import org.objectweb.jinha.editparts.SessionEditPart;
import org.objectweb.jinha.model.AttributeListModel;
import org.objectweb.jinha.model.AttributeModel;
import org.objectweb.jinha.model.BusinessMethodListModel;
import org.objectweb.jinha.model.BusinessMethodModel;
import org.objectweb.jinha.model.CMPListModel;
import org.objectweb.jinha.model.CMPModel;
import org.objectweb.jinha.model.CMRListModel;
import org.objectweb.jinha.model.CMRModel;
import org.objectweb.jinha.model.DiagramModel;
import org.objectweb.jinha.model.EntityModel;
import org.objectweb.jinha.model.FinderListModel;
import org.objectweb.jinha.model.FinderModel;
import org.objectweb.jinha.model.HomeMethodListModel;
import org.objectweb.jinha.model.HomeMethodModel;
import org.objectweb.jinha.model.MessageDrivenModel;
import org.objectweb.jinha.model.RelationModel;
import org.objectweb.jinha.model.SessionModel;

/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 */
public class EditPartFactoryImpl implements EditPartFactory {

    
    /**
     * @param context
     * @param model
     * @return
     * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart, java.lang.Object)
     */
    public EditPart createEditPart(EditPart context, Object model) {
        System.out.println("hop");
        if (model instanceof DiagramModel) {
            DiagramEditPart part = new DiagramEditPart();
            part.setModel(model);
            System.out.println("diagramditpart built");
            return part;
        }
        if (model instanceof SessionModel) {
            SessionEditPart part = new SessionEditPart();
            part.setModel(model);
            System.out.println("SessionEditPart built");
            return part;
        }
        if (model instanceof EntityModel) {
            EntityEditPart part = new EntityEditPart();
            part.setModel(model);
            System.out.println("EntityEditPart built");
            return part;
        }
        if (model instanceof MessageDrivenModel) {
            MessageDrivenEditPart part = new MessageDrivenEditPart();
            part.setModel(model);
            System.out.println("MessageDrivenEditPart built");
            return part;
        }
        if (model instanceof BusinessMethodListModel) {
            BusinessMethodListEditPart part = new BusinessMethodListEditPart();
            part.setModel(model);
            System.out.println("methodlisteditpart built");
            return part;
        }
        if (model instanceof CMPListModel) {
            CMPListEditPart part = new CMPListEditPart();
            part.setModel(model);
            System.out.println("CMPListListEditPart built");
            return part;
        }
        if (model instanceof CMPModel) {
            CMPEditPart part = new CMPEditPart();
            part.setModel(model);
            System.out.println("CMPListListEditPart built");
            return part;
        }
        if (model instanceof CMRListModel) {
            CMRListEditPart part = new CMRListEditPart();
            part.setModel(model);
            System.out.println("CMRListListEditPart built");
            return part;
        }
        if (model instanceof CMRModel) {
            CMREditPart part = new CMREditPart();
            part.setModel(model);
            System.out.println("CMPListListEditPart built");
            return part;
        }
        if (model instanceof FinderListModel) {
            FinderListEditPart part = new FinderListEditPart();
            part.setModel(model);
            System.out.println("FinderListEditPart built");
            return part;
        }
        if (model instanceof FinderModel) {
            FinderEditPart part = new FinderEditPart();
            part.setModel(model);
            System.out.println("CMPListListEditPart built");
            return part;
        }
        if (model instanceof AttributeListModel) {
            AttributeListEditPart part = new AttributeListEditPart();
            part.setModel(model);
            System.out.println("attributelisteditpart built");
            return part;
        }

        if (model instanceof AttributeModel) {
            AttributeEditPart part = new AttributeEditPart();
            part.setModel(model);
            System.out.println("attributeeditpart built");
            return part;
        }
        if (model instanceof HomeMethodListModel) {
            HomeMethodListEditPart part = new HomeMethodListEditPart();
            part.setModel(model);
            System.out.println("HomeMethodlisteditpart built");
            return part;
        }
        if (model instanceof HomeMethodModel) {
            HomeMethodEditPart part = new HomeMethodEditPart();
            part.setModel(model);
            System.out.println("HomeMethodEditPart built");
            return part;
        }
        if (model instanceof BusinessMethodModel) {
            BusinessMethodEditPart part = new BusinessMethodEditPart();
            part.setModel(model);
            System.out.println("methodeditpart built");
            return part;
        }
        if (model instanceof RelationModel) {
            RelationEditPart part = new RelationEditPart();
            part.setModel(model);
            System.out.println("RelationEditPart built");
            return part;
        }
        System.out.println("erreur dans l'editpartfactory !!!");
        return null;
    }
}