package org.objectweb.jinha.commands;

import org.objectweb.jinha.model.ListModel;

/**
 * change the constraint (order in the list) of an element (method, CMP,CMR...) in a ejb's list
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class ListElementChangeConstraintCommand extends MainCommand {

    private Object    child;

    private Object    after;

    private ListModel list;

    private int       oldChildIndex;

    /**
     * @param list the list where the object is
     * @param child the object
     * @param after 
     */
    public ListElementChangeConstraintCommand(ListModel list, Object child,
            Object after) {
        this.child = child;
        this.after = after;
        this.list = list;
    }

    /**
     * performs the change of constraint
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        System.out.println("qsdf");
        oldChildIndex = list.getIndexOf(child);
        if (after == null) {//il faut insrer l'enfant  la fin
            if (list.getIndexOf(child) != list.getSize() - 1) {//il n'y est pas
                                                               // dj
                list.removeElement(child);
                list.addElement(child);
                System.out.println("qsdf2");
            }
        }
        else {
            int indexChild = list.getIndexOf(child);
            int indexAfter = list.getIndexOf(after);
            if (indexAfter != indexChild && indexAfter != indexChild + 1) {//la
                                                                           // position
                                                                           // de
                                                                           // l'enfant
                                                                           // doit
                                                                           // changer
                list.removeElement(child);
                if (indexAfter < indexChild) {//indexAfter n'a pas chang suite
                                              // au retrait de child
                    list.addElement(child, indexAfter);
                }
                else {//indexAfter a dcru de 1 suite au retrait de child
                    list.addElement(child, indexAfter - 1);
                }
                System.out.println("qsdf3");
            }
        }
    }

    /**
     * same as execute()
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        execute();
    }

    /**
     * restore the old constraint
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        list.removeElement(child);
        list.addElement(child, oldChildIndex);
    }
}