package org.objectweb.jinha.editparts;
 
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.objectweb.jinha.figures.FinderListFigure;
import org.objectweb.jinha.model.FinderListModel;

/**
 * @author LAFON Jerome, CRESSON Sylvain, PIGNARD Quentin
 *
  */
public class FinderListEditPart extends ListEditPart {

    /**
     * @return the figure associated with this part
     * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
     */
    public IFigure createFigure() {
        return new FinderListFigure();
    }

    /**
     * @return the list of children
     * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
     */
    public List getModelChildren() {
        return ((FinderListModel) getModel()).getElementList();
    }
}